diff --git a/MAINTAINERS b/MAINTAINERS
index 70a7a1371..c4619174a 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -1094,7 +1094,7 @@ F: lib/librte_port/
 F: lib/librte_table/
 F: doc/guides/prog_guide/packet_framework.rst
 F: test/test/test_table*
-F: test/test-pipeline/
+F: app/test-pipeline/
 F: doc/guides/sample_app_ug/test_pipeline.rst
 F: examples/ip_pipeline/
 F: doc/guides/sample_app_ug/ip_pipeline.rst
diff --git a/app/Makefile b/app/Makefile
index 7f397f3d5..2940ac38f 100644
--- a/app/Makefile
+++ b/app/Makefile
@@ -8,6 +8,7 @@ DIRS-$(CONFIG_RTE_PROC_INFO) += proc-info
 DIRS-$(CONFIG_RTE_LIBRTE_PDUMP) += pdump
 DIRS-$(CONFIG_RTE_LIBRTE_CMDLINE) += cmdline_test
 DIRS-$(CONFIG_RTE_LIBRTE_ACL) += test-acl
+DIRS-$(CONFIG_RTE_LIBRTE_PIPELINE) += test-pipeline
 
 ifeq ($(CONFIG_RTE_LIBRTE_BBDEV),y)
 DIRS-$(CONFIG_RTE_TEST_BBDEV) += test-bbdev
diff --git a/app/meson.build b/app/meson.build
index 5865d5e01..6053af7c1 100644
--- a/app/meson.build
+++ b/app/meson.build
@@ -9,6 +9,7 @@ apps = ['cmdline_test',
 	'test-compress-perf',
 	'test-crypto-perf',
 	'test-eventdev',
+	'test-pipeline',
 	'test-pmd']
 
 # for BSD only
diff --git a/test/test-pipeline/Makefile b/app/test-pipeline/Makefile
similarity index 100%
rename from test/test-pipeline/Makefile
rename to app/test-pipeline/Makefile
diff --git a/test/test-pipeline/config.c b/app/test-pipeline/config.c
similarity index 100%
rename from test/test-pipeline/config.c
rename to app/test-pipeline/config.c
diff --git a/test/test-pipeline/init.c b/app/test-pipeline/init.c
similarity index 100%
rename from test/test-pipeline/init.c
rename to app/test-pipeline/init.c
diff --git a/test/test-pipeline/main.c b/app/test-pipeline/main.c
similarity index 100%
rename from test/test-pipeline/main.c
rename to app/test-pipeline/main.c
diff --git a/test/test-pipeline/main.h b/app/test-pipeline/main.h
similarity index 100%
rename from test/test-pipeline/main.h
rename to app/test-pipeline/main.h
diff --git a/app/test-pipeline/meson.build b/app/test-pipeline/meson.build
new file mode 100644
index 000000000..5578b414d
--- /dev/null
+++ b/app/test-pipeline/meson.build
@@ -0,0 +1,14 @@
+# SPDX-License-Identifier: BSD-3-Clause
+# Copyright(c) 2019 Intel Corporation
+
+sources = files(
+	'config.c',
+	'init.c',
+	'main.c',
+	'pipeline_acl.c',
+	'pipeline_hash.c',
+	'pipeline_lpm.c',
+	'pipeline_lpm_ipv6.c',
+	'pipeline_stub.c',
+	'runtime.c')
+deps += 'pipeline'
diff --git a/test/test-pipeline/pipeline_acl.c b/app/test-pipeline/pipeline_acl.c
similarity index 100%
rename from test/test-pipeline/pipeline_acl.c
rename to app/test-pipeline/pipeline_acl.c
diff --git a/test/test-pipeline/pipeline_hash.c b/app/test-pipeline/pipeline_hash.c
similarity index 100%
rename from test/test-pipeline/pipeline_hash.c
rename to app/test-pipeline/pipeline_hash.c
diff --git a/test/test-pipeline/pipeline_lpm.c b/app/test-pipeline/pipeline_lpm.c
similarity index 100%
rename from test/test-pipeline/pipeline_lpm.c
rename to app/test-pipeline/pipeline_lpm.c
diff --git a/test/test-pipeline/pipeline_lpm_ipv6.c b/app/test-pipeline/pipeline_lpm_ipv6.c
similarity index 100%
rename from test/test-pipeline/pipeline_lpm_ipv6.c
rename to app/test-pipeline/pipeline_lpm_ipv6.c
diff --git a/test/test-pipeline/pipeline_stub.c b/app/test-pipeline/pipeline_stub.c
similarity index 100%
rename from test/test-pipeline/pipeline_stub.c
rename to app/test-pipeline/pipeline_stub.c
diff --git a/test/test-pipeline/runtime.c b/app/test-pipeline/runtime.c
similarity index 100%
rename from test/test-pipeline/runtime.c
rename to app/test-pipeline/runtime.c
diff --git a/doc/guides/sample_app_ug/test_pipeline.rst b/doc/guides/sample_app_ug/test_pipeline.rst
index a9370c80b..5f313c529 100644
--- a/doc/guides/sample_app_ug/test_pipeline.rst
+++ b/doc/guides/sample_app_ug/test_pipeline.rst
@@ -32,7 +32,7 @@ Compiling the Application
 -------------------------
 To compile the sample application see :doc:`compiling`
 
-The application is located in the ``$RTE_SDK/test/test-pipline`` directory.
+The application is located in the ``$RTE_SDK/app/test-pipline`` directory.
 
 
 Running the Application
diff --git a/test/Makefile b/test/Makefile
index 0b7a3ed96..e9ae64b59 100644
--- a/test/Makefile
+++ b/test/Makefile
@@ -4,6 +4,5 @@
 include $(RTE_SDK)/mk/rte.vars.mk
 
 DIRS-$(CONFIG_RTE_APP_TEST) += test
-DIRS-$(CONFIG_RTE_LIBRTE_PIPELINE) += test-pipeline
 
 include $(RTE_SDK)/mk/rte.subdir.mk